summaryrefslogtreecommitdiffstats
path: root/system/thermald
diff options
context:
space:
mode:
author Aaditya Bagga <aaditya_gnulinux@zoho.com>2017-02-26 13:08:39 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2017-02-26 13:08:39 +0700
commit44889319aa503ac6a4784997e4d77b2f96ed0efc (patch)
tree611e126b716a10af1b13647bd7fabb3359ee062e /system/thermald
parentbdb0f08846f0edd306b2da3238ba7aa5d45610f4 (diff)
downloadslackbuilds-44889319aa503ac6a4784997e4d77b2f96ed0efc.tar.gz
slackbuilds-44889319aa503ac6a4784997e4d77b2f96ed0efc.tar.xz
system/thermald: Added (Linux Thermal Daemon).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'system/thermald')
-rw-r--r--system/thermald/README16
-rw-r--r--system/thermald/README.Slackware14
-rw-r--r--system/thermald/doinst.sh15
-rw-r--r--system/thermald/slack-desc19
-rw-r--r--system/thermald/thermald.SlackBuild108
-rw-r--r--system/thermald/thermald.info10
6 files changed, 182 insertions, 0 deletions
diff --git a/system/thermald/README b/system/thermald/README
new file mode 100644
index 0000000000..6326501691
--- /dev/null
+++ b/system/thermald/README
@@ -0,0 +1,16 @@
+The Linux Thermal Daemon program from 01.org
+
+Thermald deals with thermal issues for intel processor families
+codenamed intel sandy-bridge and above. It is a Linux daemon
+used to prevent the overheating of systems. This daemon monitors
+temperature and applies compensation using available cooling methods.
+
+Prefers kernel with:
+ Intel RAPL power capping driver : Available from Linux kernel 3.13.rc1
+ Intel P State driver (Available in Linux kernel stable release)
+ Intel Power clamp driver (Available in Linux kernel stable release)
+
+ CONFIG_X86_MSR, so that x86 MSR can be read/write from user space
+ to control RAPL if no RAPL powecap class driver is not present.
+
+ If none of the above is available uses cpufreq to control P states.
diff --git a/system/thermald/README.Slackware b/system/thermald/README.Slackware
new file mode 100644
index 0000000000..9b4624d644
--- /dev/null
+++ b/system/thermald/README.Slackware
@@ -0,0 +1,14 @@
+Since this is a daemon, it can be started at boot via /etc/rc.d/rc.local:
+ /usr/sbin/thermald
+
+It might be necessary to create /var/run/thermald/ first (depending on your
+local system setup)
+
+An entry could be added to /etc/rc.d/rc.local_shutdown as well:
+ killall thermald
+
+CONFIG_X86_MSR is listed as an (optional) dependency, msr-tools
+can be installed (https://slackbuilds.org/repository/14.2/system/msr-tools/)
+
+Uptill version 1.5.4 this was present as thermal_daemon on SBo.
+To upgrade please remove thermal_daemon and install thermald.
diff --git a/system/thermald/doinst.sh b/system/thermald/doinst.sh
new file mode 100644
index 0000000000..120570687d
--- /dev/null
+++ b/system/thermald/doinst.sh
@@ -0,0 +1,15 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+config etc/thermald/thermal-conf.xml.new
+config etc/thermald/thermal-cpu-cdev-order.xml.new
diff --git a/system/thermald/slack-desc b/system/thermald/slack-desc
new file mode 100644
index 0000000000..e7d23cc482
--- /dev/null
+++ b/system/thermald/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+thermald: thermald (Linux Thermal Daemon)
+thermald:
+thermald: Thermald is a Linux daemon used to prevent system overheating.
+thermald: This daemon monitors temperature and applies compensation using
+thermald: available cooling methods.
+thermald:
+thermald: Project URL: https://github.com/01org/thermal_daemon
+thermald:
+thermald:
+thermald:
+thermald:
diff --git a/system/thermald/thermald.SlackBuild b/system/thermald/thermald.SlackBuild
new file mode 100644
index 0000000000..25410964d8
--- /dev/null
+++ b/system/thermald/thermald.SlackBuild
@@ -0,0 +1,108 @@
+#!/bin/sh
+
+# Slackware build script for thermald
+
+# Copyright 2017 Aaditya Bagga <aaditya_gnulinux@zoho.com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=thermald
+SRCNAM=thermal_daemon
+VERSION=${VERSION:-1.5.4}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.gz
+cd $SRCNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+./autogen.sh
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --build=$ARCH-slackware-linux
+
+make
+make install DESTDIR=$PKG
+
+# Remove /etc/init but keep dbus config
+rm -r $PKG/etc/init
+
+# Don't clobber configs
+mv $PKG/etc/thermald/thermal-conf.xml $PKG/etc/thermald/thermal-conf.xml.new
+mv $PKG/etc/thermald/thermal-cpu-cdev-order.xml $PKG/etc/thermald/thermal-cpu-cdev-order.xml.new
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a COPYING README.txt $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/thermald/thermald.info b/system/thermald/thermald.info
new file mode 100644
index 0000000000..57c6ae3a61
--- /dev/null
+++ b/system/thermald/thermald.info
@@ -0,0 +1,10 @@
+PRGNAM="thermald"
+VERSION="1.5.4"
+HOMEPAGE="https://github.com/01org/thermal_daemon"
+DOWNLOAD="https://github.com/01org/thermal_daemon/archive/v1.5.4/thermal_daemon-1.5.4.tar.gz"
+MD5SUM="f7b63e691fb941c92e14ccfcb667b593"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Aaditya Bagga"
+EMAIL="aaditya_gnulinux@zoho.com"